(*
DNS-O-Matic Updater Script 1.0

DNS-O-Matic Updater Script is a simple AppleScript to update your external IP on DNS-O-Matic. 
You simply put your username and password in, save it and could run it.

It has some nice advantages above other clients:
Stay out of the way
No memory usage
Really small
Easy to change on your self

You could start it an various ways:
Script Editor
Script Menu
Save it as an app to start it in the dock or your favorite app launcher
Run it as system agent by adding it with Lingon
Use it in Automator actions
Use it in shell script

Script made by Jan Kampling
http://www.blogadresse.de
Licenesed under GNU General Public License, Free Software Foundation http://creativecommons.org/licenses/GPL/2.0/
*)

property username : "YOUR USERNAME" --  <<-- Put your DNS-O-Matic username here
property pass : "YOUR PASSWORD" --  <<-- Put your DNS-O-Matic password here

set myIp to do shell script "curl http://myip.dnsomatic.com/"

set myURL to "http://" & username & ":" & pass & "@updates.dnsomatic.com/nic/update?hostname=all.dnsomatic.com&myip=" & myIp & "&wildcard=NOCHG&mx=NOCHG&backmx=NOCHG"

set dnsomatic_update to do shell script "curl " & quoted form of myURL

set myMessageItems to stringToList from dnsomatic_update for " "

growlinfo(myMessageItems)

on growlinfo(myMessageItems)
	set myApp to ""
	tell application "System Events" to set GrowlRunning to ((application processes whose (name is equal to "GrowlHelperApp")) count)
	if GrowlRunning  1 then
		try
			set myApp to "GrowlHelperApp"
			-- Inits
			set appName to "\"DNS-O-Matic Updater\""
			set notificationName to "\"DNS-O-Matic Updater Notification\""
			set notifs to "{\"DNS-O-Matic Updater Notification\"}"
			-- end Inits
			-- Register GrowlNotification 
			set myrunscript to "register as application " & appName & " all notifications " & notifs & " default notifications " & notifs & " icon of application \"Network Utility\""
			tell application myApp to run script myrunscript
			-- end Register GrowlNotification
			-- Do Growlnotification
			if item 1 of myMessageItems is "good" then
				set myDescription to "DNS-O-Matic update was sucessful. Your external IP is " & item 2 of myMessageItems
				set myTitle to "DNS-O-Matic Update"
				set myrunscript to "notify with name " & notificationName & " application name " & appName & " title " & "\"" & myTitle & "\"" & " description " & "\"" & myDescription & "\""
				tell application myApp to run script myrunscript
			else if item 1 of myMessageItems is "badauth" then
				set myDescription to "DNS-O-Matic update was NOT sucessful! Your authorisation was wrong."
				set myTitle to "DNS-O-Matic Update"
				set myrunscript to "notify with name " & notificationName & " application name " & appName & " title " & "\"" & myTitle & "\"" & " description " & "\"" & myDescription & "\""
				tell application myApp to run script myrunscript
			end if
			-- End do Growlnotification
		end try
	end if
end growlinfo

on stringToList from theString for myDelimiters
	tell AppleScript
		set theSavedDelimiters to AppleScript's text item delimiters
		set text item delimiters to myDelimiters
		set outList to text items of theString
		set text item delimiters to theSavedDelimiters
		return outList
	end tell
end stringToList

